# -*- coding: utf-8 -*-
"""
Created on Mon Jun 24 14:27:34 2019

@author: asano
"""

# 4.3節　誤差逆伝播法を手計算風に確認する
# まずはライブラリと活性化関数の準備
import numpy as np

def logistic(x):
    return 1 / (1 + np.exp(-x))

# 初期値と観測データ
    
W1 = np.array([[0.603, 0.107, 0], [1.811, -0.307, 0],[-0.165,-1.108,0]])
W2 = np.array([[1.094, -0.494,-0.239,0], [-0.253,-0.945,0.212,0]])
X = np.array([[9,6,3,3,1,5,2,1,1,2], [3,3,0,1,1,4,5,0,8,2]])
T = np.array([[0.7,0.3,0.0,0.4,0.6,0.4,0.3,0.5,0.4,0.3],[0.8,0.9,0.8,0.7,
              0.6,0.4,0.3,0.8,0.7,0.0]])

N = 10  #分析ケース数、しばしば消費者の数
L = 3   #第２層（隠れ層）のユニット数
vec1 = np.ones((1,N))
Xex  = np.vstack([X,vec1])
vecL = np.ones((L,1))
Imatrix = vecL @ vec1    #1を要素としたL行N列の行列

# フォワードステップ

S = W1 @ Xex
Z = logistic(S)
Zex= np.vstack([Z,vec1 ])
Y = W2 @ Zex
Dif = Y - T
esum = (Dif.T @ Dif).trace()/2
print(esum)
# 初回は損失関数が13.962と評価された

# バックワードステップ

DW2 = Dif @ Zex.T

# W2から第１層にリンクのないパラメータをカットする
# 次の指定はW2から最終列を削除することを意味する
# Pythonでは列番号は0からカウントするのでL列目が余分になる
W2b = np.delete(W2,L,axis=1)
DW1 = ((W2b.T @ Dif)*Z * (Imatrix - Z)) @ Xex.T

# パラメータ更新 ステップ幅は0.01　
W1 = W1 - 0.01 * DW1
W2 = W2 - 0.01 * DW2

# 再度フォワードステップを実行するとesum=7.961と小さくなった


